<?php
/**
 * Table Definition for community
 */
require_once 'DB/DataObject.php';

class Community extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'community';                       // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.community_id_seq%29 primary_key
    var $owner;                           // text(-1)  not_null
    var $createtime;                      // timestamp(8)  default_now%28%29
    var $name;                            // text(-1)  not_null
    var $category;                        // text(-1)  not_null
    var $explanation;                     // text(-1)  
    var $url;                             // text(-1)  not_null
    var $rss;                             // text(-1)  
    var $xmlrpc;                          // text(-1)  
    var $joinrule;                        // text(-1)  not_null default_open

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Community',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE
    
    // set keyword for find()
    function setKeyword($str) {
        $keywords = preg_split("/(\s|)+/",$this->escape(strtolower($str)));
        foreach($keywords as $keyword) {
            $this->whereAdd(sprintf("(lower(name) like '%%%s%%' OR lower(explanation) like '%%%s%%')",$keyword,$keyword),'AND');
        }
    }

    // Checks if a account joined at this community
    function isMember($account=null) {
        if($account==null) {
            $my = getMe();
            $account = $my->account;
        }
        $community_member = new Community_member();
        $community_member->community = $this->id;
        $community_member->member = $account;
        if($community_member->find()>0) return true;
        return false;
    }
}
?>