<?php



require_once 'XML/RSS.php';

require_once 'commands/command.php';


class RSSFeedCommand extends Command {



    var $url;

    var $article_num = 1;



    function execute() {

        $return_value = array();

        foreach( $this->url as $value ) {

            $feedgetter = new RSSFeedGetter( $value );

            array_push( $return_value, $feedgetter->getLatestItem( $this->article_num ) );

        }

        return $return_value;

    }

}



class RSSFeedGetter {

    

    var $rss_document;

    

    /*

     *    Constructor of this class. set parsed RSS Document.

     */

    function RSSFeedGetter( $url ) {

        

        //    change php configuration value "allow_url_fopen".

        if (ini_get("allow_url_fopen") == 0) {

            ini_set("allow_url_fopen", 1);

        }

        

        //    parse RSS Document

        $this->rss_document =& new XML_RSS( $url );

        $this->rss_document->parse();

    }

 

    function getLatestItem( $getting_num ) {

        $rss_contents = array();

        $items = $this->rss_document->getItems();

        for( $i = 0; $i < $getting_num; $i++ ) {

            array_push( $rss_contents, array_shift( $items ) );

        }

        return $rss_contents;

    }

    

}



?>

