<?php

//PEAR
require_once 'HTML/QuickForm.php';
require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';

//Smarty
require_once 'Smarty/Smarty.class.php';

class YMForm extends HTML_QuickForm {
    var $button_action;
    var $button_prev;
    var $smarty_template, $template_values;
  
    var $_color1,$_color2,$_color3;
    var $_form_messages = array('error_required'=>"%sɬܹܤǤ");

    function makeForm() {
        $element =& $this->addElement('hidden','__ymform_name');
        $element->setValue($this->getAttribute('name'));
        $this->form();
        if(is_string($this->button_action))
            $this->addElement('submit','__command_action',$this->button_action);
        if(is_string($this->button_prev))
            $this->addElement('submit','__command_prev',$this->button_prev);
        
    }
    
    function form() {
        // $this->addElement('submit','command_action','submit');
    }
    
    // եμ¹
    function action() {
        if (!$this->validate()) return false;
        $this->freeze();
        return true;
    }
    
    function getHTML() {
        if(!is_array($this->template_values)) $this->template_values=array();
        
        if(is_string($this->smarty_template) && $this->smarty_template!='') {
            $smarty = YMForm_Controller::createSmarty();
            $renderer =& new HTML_QuickForm_Renderer_ArraySmarty($smarty);
            $this->accept($renderer);
            $smarty->assign('val',$this->template_values);
            $smarty->assign('form',$renderer->toArray());
            return $smarty->fetch($this->smarty_template);
        }
        else {
            $renderer =& $this->defaultRenderer();
            if($this->_color1=='') $this->_color1 = '#996';
            if($this->_color2=='') $this->_color2 = '#900';
            if($this->_color3=='') $this->_color3 = '#cccc99';
            
            $this->setRequiredNote(sprintf($this->_form_messages['error_required'],'<font color="#FF0000">*</font>'));
            $this->setJsWarnings('Those fields have errors :', 'Thanks for correcting them.');
            
            $renderer->setFormTemplate('<table width="450" border="0" cellpadding="3" cellspacing="2" bgcolor="'.$this->_color3.'"><form{attributes}>{content}</form></table>');
            $renderer->setHeaderTemplate('<tr><td style="white-space:nowrap;background:'.$this->_color1.';color:#ffc;" align="left" colspan="2"><b>{header}</b></td></tr>');
            $renderer->setGroupTemplate('<table><tr>{content}</tr></table>');
            $renderer->setGroupElementTemplate('<td>{element}<br /><span style="font-size:10px;"><!-- BEGIN required --><span style="color:'.$this->_color2.'">*</span><!-- END required --><span style="color:'.$this->_color1.';">{label}</span></span></td>');
            
            $this->accept($renderer);
            return $renderer->toHtml();
        }
    }
}

function ymform_controller_applet($params) {
    $name = $params['name'];
    if(preg_match('/[^a-zA-Z0-9]/',$name)>0) return ""; // for security
    $name = strtolower( $name );
    require_once( "applet/$name.php");
    $appletname = $name."Applet";
    $applet = new $appletname();
    return $applet->execute($params);
}

class YMForm_Controller {
    var $forms;
    
    function YMForm_Controller() {
        $this->initialize();
        // $this->forms = array("page1","page1_confirm","page2");
    }
    
    function initialize() {
        return true;
    }
    
    function action() {
        return true;
    }

    function hookMakedForm(&$form) {
        return true;
    }

    // service funtion
    function createSmarty() {
        // Smartyν
        $smarty = new Smarty;
        $smarty->template_dir = TEMPLATE_DIR;

        $smarty->compile_dir = COMPILE_DIR;
        $smarty->cache_dir = CACHE_DIR;
        $smarty->register_function('applet','ymform_controller_applet');


        return $smarty;
    }
    
    function run() {
        if(array_key_exists('__ymform_name',$_REQUEST)) 
            $thispage = $_REQUEST['__ymform_name'];
        else  
            $thispage = $this->forms[0];
            
        if(array_key_exists('__command_prev',$_REQUEST)) {
            $prevpage_id = array_search($thispage,$this->forms)-1;
            if($prevpage_id<0) $prevpage_id = 0;
            $thispage = $this->forms[$prevpage_id];
            $form =& $this->makeForm($thispage);
            $result = $this->hookMakedForm($form);
            if(PEAR::isError($result)) return $result;
        }
        else {
            $form =& $this->makeForm($thispage);        
            $result = $this->hookMakedForm($form);
            if(PEAR::isError($result)) return $result;
            $pagedata = array();
            $values = $form->exportValues();
            foreach($values as $k => $v) {
                if(substr($k,0,2)!='__')
                    array_push($pagedata,urlencode($k).'='.urlencode($v));
            }
            $pagedata = join(',',$pagedata);
            $_REQUEST['__ymform_value_'.$thispage] = $pagedata;
            if($form->action()) {
                $lastpage = $thispage;
                $nextpage_id = array_search($thispage,$this->forms)+1;
                if($nextpage_id>=count($this->forms))
                    return $this->action();
                $thispage = $this->forms[$nextpage_id];
                $form =& $this->makeForm($thispage);
                
                $element =& $form->getElement('__ymform_value_'.$lastpage);
                $element->setValue($pagedata);
            }
        }
        return $form->getHTML();
    }

    function makeForm($pagename) {
        $form = $this->$pagename($pagename);
        foreach($this->forms as $pagename) {
            $element =& $form->addElement('hidden','__ymform_value_'.$pagename);
        }
        $form->makeForm();
        return $form;
    }
    
    function exportValues() {
        $values = array();
        foreach($this->forms as $pagename) {
            $values[$pagename] = array();
            if(array_key_exists('__ymform_value_'.$pagename,$_REQUEST)) {
                foreach(split(',',$_REQUEST['__ymform_value_'.$pagename]) as $line) {
                    list($key,$value) = split('=',$line,2);
                    $values[$pagename][urldecode($key)] = urldecode($value);
                }
            }
        }
        return $values;
    }
}

?>
