<?php
// $Id: ymform.php,v 1.1 2004/06/15 00:47:14 halt1983 Exp $

require_once 'Smarty.class.php';
require_once "HTML/QuickForm.php";
require_once "HTML/QuickForm/Controller.php";
require_once "HTML/QuickForm/Action/Next.php";
require_once "HTML/QuickForm/Action/Back.php";
require_once "HTML/QuickForm/Action/Jump.php";
require_once "HTML/QuickForm/Action/Submit.php";
require_once "HTML/QuickForm/Action/Display.php";
require_once "HTML/QuickForm/Renderer/ArraySmarty.php";

// QuickForm needs Session
if(empty($_SESSION)) session_start();

class YMForm extends HTML_QuickForm_Page {
  var $_submits = array();
  var $_freeze = FALSE;
  var $_smarty_template = FALSE;
  var $frame_template = '';
  var $_form_messages = array('error_required'=>'%sɬܹܤǤ');
  var $_color1, $_color2, $_color3;

  function YMForm($formName='', $method='post', $target='_self', $attributes=null) {
    $this->HTML_QuickForm_Page($formName, $method, $target, $attributes);
  }

  function makeController($formName) {
    $wizard =& new HTML_QuickForm_Controller($formName);
    $wizard->addAction("next", new HTML_QuickForm_Action_Next());
    $wizard->addAction("back", new HTML_QuickForm_Action_Back());
    $wizard->addAction("jump", new HTML_QuickForm_Action_Jump());
    $wizard->addAction("submit", new HTML_QuickForm_Action_Submit());
    $wizard->addAction("display", new YMActionDisplay());
    $wizard->addAction("process", new YMActionProcess());

    return $wizard;
  }

  function addRule_required($elementName,$label) {
    $this->addRule($elementName, sprintf($this->_form_message['error_required'],$label), 'required', '');
  }

  // example
  // function form1() {
  //  $this->addElement('text', 'username', 'Your email address :', array('size' => 30, 'maxlength' => 63));
  //  $this->addElement('text', 'username1', 'Your email address1 :', array('size' => 30, 'maxlength' => 63));
  //  $this->addElement('text', 'username2a', 'Your email address2 :', array('size' => 30, 'maxlength' => 63));
  // }

  function buildForm() {
    call_user_func(array(&$this,"buildForm_".$this->getAttribute('name')));
  }
  
  function setDefault() {;}
  
  function action($action,$actionName) {
    $values = $this->controller->exportValues();
    echo '<pre>';
    var_dump($values);
    echo '</pre>';
  }
  
  function createSmarty() {
    // Smartyν
    $smarty = new Smarty;
    $smarty->template_dir = "./templates";
    $smarty->compile_dir = "./templates_c";
    $smarty->cache_dir = "./cache";
    return $smarty;
  }
  
  function displayErrorPage($message,$template='error.tpl') {
    $smarty = YMForm::createSmarty();
    $smarty->assign('message',$message);
    $smarty->display($template);
  }
  
  function checkDB($rs,$file='',$line='', $rollback=true) {
    if (DB::isError($rs)) {
      $this->errorPage("DBƥ२顼 $file($line)");
      if($rollback) $rs = $this->conn->query("ROLLBACK;");
      return false;
    }
    return true;
  }
  
}

class YMActionDisplay extends HTML_QuickForm_Action_Display {
  var $frame_template;
  
  function _renderForm(&$page) {
    if ($page->_freeze == true) {
      $page->freeze();
    }
    if (is_array($page->_submits) && !empty($page->_submits)) {
      // ֥ߥåȥܥ󥰥롼פ
      $submits = array();
      foreach($page->_submits as $name=>$value) {
	$submits[] =& $page->createElement("submit", $page->getButtonName($name), $value);
      }
      $page->addGroup($submits, "submits", "", "&nbsp;", false);
    }

    if($page->_smarty_template==FALSE) {
      // SmartyʤʤŬ
      $renderer =& $page->defaultRenderer();
      if($page->_color1=='') $page->_color1 = '#996';
      if($page->_color2=='') $page->_color2 = '#900';
      if($page->_color3=='') $page->_color3 = '#cccc99';


      $page->setRequiredNote(sprintf($page->_form_messages['error_required'],'<font color="#FF0000">*</font>'));
      $page->setJsWarnings('Those fields have errors :', 'Thanks for correcting them.');

      $renderer->setFormTemplate('<table width="450" border="0" cellpadding="3" cellspacing="2" bgcolor="'.$page->_color3.'"><form{attributes}>{content}</form></table>');
      $renderer->setHeaderTemplate('<tr><td style="white-space:nowrap;background:'.$page->_color1.';color:#ffc;" align="left" colspan="2"><b>{header}</b></td></tr>');
      $renderer->setGroupTemplate('<table><tr>{content}</tr></table>');
      $renderer->setGroupElementTemplate('<td>{element}<br /><span style="font-size:10px;"><!-- BEGIN required --><span style="color:'.$page->_color2.'">*</span><!-- END required --><span style="color:'.$page->_color1.';">{label}</span></span></td>');

      $page->accept($renderer);
      $contents = $renderer->toHtml();
    }
    else {
      // _smarty_templateʤSmarty
      $smarty = YMForm::createSmarty();
      $renderer =& new HTML_QuickForm_Renderer_ArraySmarty($smarty);
      $page->accept($renderer);
      $smarty->assign('form',$renderer->toArray());
      $contents = $smarty->fetch($page->_smarty_template);
    }

    $smarty = YMForm::createSmarty();
    $smarty->assign('contents',$contents);
    $smarty->display($page->frame_template==''?"frame.tpl":$page->frame_template);
  }
}

class YMActionProcess extends HTML_QuickForm_Action {
  function perform(&$page, $actionName) {
    $page->action($this,$actionName);
  }
}

?>
