<?php
// $Id: ymmail.php,v 1.3 2004/07/17 19:35:17 masui Exp $

// Example:
//  $mail = new YMMail();
//  $mail->send_from_template('test.tpl','masui@hisec.co.jp',array('name'=>'','mail'=>'masui@hisec.co.jp'));

require_once 'Mail.php';
require_once 'Smarty/Smarty.class.php';

class YMMail extends Mail {
  var $mail_object;

  function YMMail($backend='mail',$param = array()) {
    $this->mail_object =& Mail::factory($backend);
  }

  function createSmarty() {
    // Smartyν
    $smarty = new Smarty;
    $smarty->template_dir = LIBDIR."mail_templates";
    $smarty->compile_dir = LIBDIR."mail_templates_c";
    $smarty->cache_dir = LIBDIR."mail_cache";
    return $smarty;
  }
  
  function send_from_template($tpl, $recipients, $values=array()) {
    $headers = array();
    $smarty = $this->createSmarty();
    $smarty->assign($values);
    $mailtext = $smarty->fetch($tpl);
    
    list($headertext, $body) = split("\n\n",$mailtext,2);
    foreach(split("\n",$headertext) as $headerline) {
      list($k,$v) = split(":",$headerline,2);
      $headers[trim($k)] = trim($this->to_mime($v));
    }
    
    $headers['Content-Type'] = 'text/plain; charset="iso-2022-jp"';
    $headers['Content-Transfer-Encoding'] = '7bit';
    $headers['MIME-Version'] = '1.0';
    $this->mail_object->send($recipients,$headers,mb_convert_encoding($body,'jis','euc-jp'));
  }
  
  // from http://www.tktools.jp/%7Eiwa/to_mime.phps
  function parse_euc_ascii($string) {
    $retval = array();
    while (strlen($string)) {
      if (substr($string, 0 , 1) < "\x7f") {
	@list($ret, $string, $c) = preg_split("/([\x80-\xff])/", $string, 2, PREG_SPLIT_DELIM_CAPTURE);
	$ret = split(' ', $ret);
	$retval[] = array(0, array_shift($ret));
	while (count($ret)) {
	  $retval[] = array(1, array_shift($ret));
	}
      } else {
	@list($ret, $string, $c) = preg_split("/([\x01-\x7f])/", $string, 2, PREG_SPLIT_DELIM_CAPTURE);
	$retval[] = array(2, $ret);
      }
      $string .= $c;
    }
    return $retval;
  }
  
  // from http://www.tktools.jp/%7Eiwa/to_mime.phps
  function to_mime($str) {
    $parts = $this->parse_euc_ascii($str);
    $encode_header = '=?ISO-2022-JP?B?';
    $encode_footer = '?=';
    $headfoot_len = strlen($encode_header . $encode_footer);
    
    $header_length = 0;
    $header = '';
    
    foreach ($parts as $p) {
      while ($p[1] !== NULL) {
	$len = strlen($p[1]);
	if ($p[0] < 2) {
	  if ($p[0] == 1) {
	    $header .= ' ';
	  }
	  $header .= $p[1];
	  $p[1] = NULL;
	  $header_length += $len + $p[0];
	} else {
	  $new_length = $header_length + $headfoot_len + (int)ceil(($len+6)/3.0) * 4;
	  $header .= $encode_header . base64_encode(mb_convert_encoding($p[1], 'jis', 'euc-jp')) . $encode_footer;
	  $p[1] = NULL;
	  $header_length = $new_length;
	}
      }
    }
    return $header;
  } 
};

?>
