#!/bin/sh

APACHE_DIR=/usr/local/apache 

#if [ `id -u` -ne 0 ]; then
#    echo 'you must be root to execute this script'
#    exit 1;
#fi 

check_install() {

   local requirement

   case $1 in
       apache)
           requirement='1.3 or 2.0' 
           ;;
       php)
           requirement='4.2'
           ;;
       postgresql)
           requirement='7.2'
           ;;
   esac  
 
   echo "$1 installation check...." 
   locate $2 1> /dev/null && echo "$1 check ok"
   if [ $? -ne 0 ]; then
       echo "we cant detect $1 installation on your machine"
       echo "if you install it, please input location of $search_file"
       read install_dir 
       if [ -f $install_dir ]; then
           echo "$1 check ok"
       else
           echo 'we cant detect apache installation on your machine'
           echo "you must install $1 $requirement higher"
           exit 1
       fi
   fi
}

check_install 'apache' 'httpd.conf'
check_install 'php'    'php.ini'
check_install 'postgresql' 'postmaster'

echo "installation check ok."
#echo "pear module install."

#pear module install
#pear install Date
#pear install Mail
#pear install DB_DataObject
#pear install HTML_Common
#pear install HTML_QuickForm
#pear install HTML_QuickForm_Controller
#pear install Log
#pear install XML_Parser
#pear install XML_Tree
#pear install XML_Util
#pear install XML_RPC
#pear install XML_RSS

echo "change permissions"
mkdir public_html/photos libs/cache libs/templates_c libs/mail_cache libs/mail_templates_c 
chmod 777 public_html/photos libs/cache libs/templates_c libs/mail_cache libs/mail_templates_c 

echo "create database"
locate psql > /dev/null
if [ $? -ne 0 ]; then
	echo "cannot find 'psql' command. please check PATH"
	exit 1
fi
locate createdb > /dev/null
if [ $? -ne 0 ]; then
	echo "cannot find 'createdb' command. please check PATH"
	exit 1
fi
createdb friends
psql -c "CREATE USER friends WITH PASSWORD 'friends';" friends || exit
psql friends -U friends -f friends.psql

echo ''
echo 'Congraturations! we finished installing required software of wawawa'
echo "please select your wawawa's installation directory which must be under"
echo 'the DocumentRoot of your Web Server[/usr/local/apache/htdocs]'
echo
echo "DONE."


